/**\file lcd.h
 * LCD functions
 */

#ifndef LCD_H
#define LCD_H

#include "console.h"
#include "lcdfonts.h"

#define ROM_CHAR_PTR code char*
void LcdSelectFont(ROM_CHAR_PTR font);

extern code const unsigned char lcd_hexchars[17];

/** Low level: Move LCD Cursor to start of the first line */
#define LcdLocateHome(){LcdPutCommand (128);InitiateDelay(39);}

/** Low level: Move LCD Cursor to start of the second line */
#define LcdLocateLine2(){LcdPutCommand (168);InitiateDelay(39);}

/** Low level: Point to start of LCD Character Generator RAM */
#define LcdLocateCG(){LcdPutCommand (64);InitiateDelay(39);}

void LcdPutChar(char c);
void LcdPutCommand(char cmd);
void LcdReset();
void LcdPutString(char *str);
void LcdPutConstantString(char code *str);
void LcdSplashScreen();
void LcdPutHex8 (unsigned char value);
void LcdPutHex16 (unsigned int value);
unsigned char LcdPrintGenericResult (unsigned char errorlevel);
void LcdPutUInt(unsigned long value);


#endif
