/** \file ui.h User Interface common definitions - functions are still in player.c */

#ifndef UI_H
#define UI_H

/** User Interface Modes */
typedef enum {
  //UI_MODE,      
  UI_MIDISOURCE,
  UI_MIDIFILE,      
  UI_WAVEFILE,      
  UI_RECORDFILE,
  UI_MIDITRANSPOSE,
  UI_MIDIVOLUME,
  UI_WAVEVOLUME,
  UI_MIC_VOLUME,
  UI_MIC_GAIN,
  UI_VOLUME,       /**< Volume setting                 */
  UI_ECHOMODE,
  UI_BASS,         /**< Bass enhancer setting          */
  UI_TREBLE,       /**< Treble enhancer setting        */
  UI_MIDI_CH1,
  UI_MIDI_CH2,
  UI_MIDI_CH3,
  UI_MIDI_CH4,
  UI_MIDI_CH5,
  UI_MIDI_CH6,
  UI_MIDI_CH7,
  UI_MIDI_CH8,
  UI_MIDI_CH9,
  UI_MIDI_CH10,
  UI_MIDI_CH11,
  UI_MIDI_CH12,
  UI_MIDI_CH13,
  UI_MIDI_CH14,
  UI_MIDI_CH15,
  UI_MIDI_CH16,
  UI_END_OF_MODES  /**< Nothing, jump go to first mode */
} uimodetype;
extern xdata uimodetype uiMode;

/** Playing states. \todo safe rewind */
typedef enum {
  PS_NORMAL = 0,    /**< Continue playing, do nothing special      */
  PS_END_OF_SONG,   /**< Request termination of current song       */
  PS_NEXT_SONG,     /**< Request next song                         */
  PS_PREVIOUS_SONG, /**< Request previous song                     */
  PS_CUE,           /**< Request to start fast forward             */
  PS_CUE_WAIT1003,  /**< WMA: wait for permission to break stream  */
  PS_CUE_ACTION,    /**< Just do it. */
  PS_REWIND,        /**< Request to start rewind (not implemented) */
  PS_REW_WAIT1003,  /**< WMA: wait for permission to break stream  */
  PS_FALLBACK_1,    /**< Start fallback to normal after ff/rew     */
  PS_FALLBACK_N,    /**< fallbackCount sectors to PS_NORMAL        */
  PS_RECORDING      /**< Recording mode */

} playingstatetype;
//extern xdata playingstatetype playingState;


#define NEXT_THRESHOLD (2)
#define PREV_THRESHOLD (-2)

extern xdata unsigned char volume;


#endif
